Components.utils.import('resource://papaya/string.jsm');
Components.utils.import('resource://papaya/xmpp.jsm');


/***********************************************************************
 *  Section 1: papayaChat
 **********************************************************************/
function papayaChatContact() {
  this.waitingBuffer = new Array();
  this.chatBuffer = new Array();
}
papayaChatContact.prototype = {
  chatBuffer : 0,
  lastFrom : -1,                 //from contact: 1, from user: 0
  lastResource : 0,
};

var   papayaChat = {
  defaultElement : 0,
  current : 0,
  currentElm : 0, //"im" elm of this.current
  communicator : 0,

  /** Init fct
   */
  init : function() {
    this.current = this.defaultElement;
    chatParser.init();

    this.communicator = new communicatorX2H("papaya-message", "empty", papayaChat.listener);
  },
  
  listener : function(evt) {
    if(evt.target.getAttribute("type") == "link") {
      BrowserUI.newTab(evt.target.getAttribute("value"), true);
    }
  },

  switchToElement : function(contact) {
    if(typeof(contact) == "string") {
      contact = papayaRoster.returnPresence(contact);
    }
//FIXME: putSidebar?
    papayaUI.setPanel("papaya-im-container");
    var doc = document.getElementById("papaya-message");

    if(this.current == contact)
      return;

    var elm = contact.elmGet("im");
    if(!elm) {
      elm = contact.elmCreateFrom("im", papayaChatContact);
    }
    
    if(!contact.muc && contact.mainResource) {
      if(!contact.mainResourceMode) {
        contact.mainResourceMode = 1;
      }
      if(contact.mainResourceMode == 1) {
        contact.mainResource = (elm.lastResource) ? elm.lastResource : contact.getBestPriority();
      }
    }

    if(this.currentElm && elm != this.currentElm)
      this.currentElm.chatBuffer = doc.contentDocument.body.innerHTML;

    this.current = contact;
    this.currentElm = elm;
    this.current.sidebarObject.setAttribute("blink", false);
    this.currentElm.lastFrom = -1;

    doc.contentDocument.getElementById("messages").innerHTML = elm.chatBuffer;
    document.getElementById("papaya-im-toolbar-muc").hidden = !this.current.muc;
    papayaChatUI.smileyBoxSwitch(true);

    doc.contentWindow.scrollBy(0, parseInt(doc.contentDocument.body.scrollHeight));
  },

  message : function(msg) {
    var jid = papayaStr.getBareJID(msg.@from.toString());
    var useUrl = false;
    var text = "";
    if(msg..ns_xhtml::body.*.length()) {
      text = chatParser.xhtmlSecure(msg..ns_xhtml::body.*);
    }
    else {
      text = chatParser.parse(msg..body.toString());
      useUrl = true;
    }

    if(msg.@type == "groupchat") {
      var muc = papayaRoster.getMuc(jid); //don't use setMuc for security

      if(!muc.sidebarObject)  muc.putSidebar();

      this.putInMucMsg(muc, msg.@from.toString(), text, useUrl);
    }
    else {
      var contact = papayaRoster.returnPresence(jid);
      
      if(msg.@type == "normal" && msg..subject.length())
        text = "<b>" + msg..subject.toString() + "</b>: " + text;

      if(contact.muc){
        contact = contact.get(msg.@from.toString());
        if(!contact) return;
      }
      else
      if(!contact.sidebarObject)  contact.putSidebar();

      this.putInMsg(contact, msg.@from.toString(), text, useUrl);
    }
  },

  putInMucMsg : function(muc, id, text, info, useUrl) {
    var elm = muc.elmGet("im");
    if(!elm)
      elm = muc.elmCreateFrom("im", papayaChatContact);
      
    if(muc.jid == id) {
      //~ if(elm.lastFrom == "infos") ndiv = false;
      //~ else                        elm.lastFrom = "infos";

      text = chatParser.toInfosDiv(text);
    }
    else {
      if(muc != this.current)
        if(papayaStr.isSubString(text, papayaRoster.myInfos.name)) {
          muc.sidebarObject.setAttribute("blink", true);
        }

      var contact = muc.get(id);
      var avatar = "chrome://papaya/skin/anonym.png";

      if(papayaStr.stringAtBegin("/me ", text)) {
        this.putInfos(muc, ((contact) ? contact.name : papayaStr.getResource(id)) + text.substr(3));
        return;
      }

      if(contact)
        if(contact.avatar) avatar = contact.avatar;
        
      //~ if(elm.lastFrom == id)  ndiv = false;
      //~ else                    elm.lastFrom = id;
      text = chatParser.toMucDiv(papayaStr.getResource(id), avatar, text, useUrl);
    }
    this.putText(muc, elm, text);
  },

  putInMsg : function(contact, id, text, useUrl) {
    var elm = contact.elmGet("im");
    if(!elm)  elm = contact.elmCreateFrom("im", papayaChatContact);

    contact.putSidebar(false);

    if(contact != this.current || !this.isVisible())
      contact.sidebarObject.setAttribute("blink", "true");

    if(!papayaUI.isVisible()) {
      let alertText = chatParser.stripHTML(text);
      papayaUI.alert((contact.avatar)? contact.avatar : "chrome://papaya/skin/anonym.png", 
                     contact.name, 
                     (text.length > 101) ? alertText.substring(0, 100) + "..." : alertText);
    }

    if(contact.mainResource) {
      elm.lastResource = contact.getResource(id);
      if(!elm.lastResource) 
        elm.lastResource = contact.setResource(id, papayaStr.getResource(id), 0);
      if(contact.mainResourceMode == 1) 
        contact.mainResource = elm.lastResource;
    }

    if(papayaStr.stringAtBegin("/me ", text)) {
      this.putInfos(contact, contact.name + text.substr(3));
      return;
    }

    text = chatParser.toInDiv(text, (contact.avatar)? contact.avatar : "chrome://papaya/skin/anonym.png");
    this.putText(contact, elm, text);
    elm.lastFrom = 1;
  },

  putOut : function(contact, text) {
    if(papayaStr.stringAtBegin("/me ", text)) {
      this.putInfos(0, papayaRoster.myInfos.name + text.substr(3));
      return;
    }

    text = chatParser.toOutDiv(text, papayaRoster.myInfos.avatar);
    this.putText(contact, 0, text);
    this.currentElm.lastFrom = 0;
  },

  putInfos : function(contact, text) {
    text = chatParser.toInfosDiv(text);
    this.putText(contact, 0, text, true);
    this.currentElm.lastFrom = 2;
  },

  putText : function(contact, elm, text) {
    if(!contact) {
      contact = this.current;
      elm = this.currentElm;
    }
    else
    if(!elm) { 
      elm = contact.elmGet("im");
      if(!elm) elm = contact.elmCreateFrom("im", papayaChatContact);
    }

    if(contact == this.current) {
      let doc = document.getElementById("papaya-message");
      let empty = doc.contentDocument.getElementById("empty");
      empty.innerHTML +=text;
      let msg = doc.contentDocument.getElementById("messages");
      msg.appendChild(empty.childNodes[0]);

      while(msg.childNodes.length > 50)
        msg.removeChild(msg.childNodes[0]);
      
      doc.contentWindow.scrollBy(0, parseInt(doc.contentDocument.body.scrollHeight));
    }
    else {
      elm.chatBuffer += text;
    }
  },
  
  isVisible : function() {
    //TODO: deck visible
    return (document.getElementById("papaya-panels").selectedPanel == document.getElementById("papaya-im-container") &&
            papayaUI.isVisible("papaya-im-container"));
  },

  send : function(contact, text, htmlText) {
    if(text.length == 0)    return;
    if(!contact) {
      contact = papayaChat.current;
    }
    else
    if(typeof(contact) == "string") {
      contact = papayaRoster.returnPresence(contact);
    }

    var type;
    var to = contact.getDstJID();
    if(contact.muc)    type = "groupchat";
    else               type = "chat";

    var stanza = _message.send(to, text, (htmlText) ? htmlText : 0, type);

    XMPP.accounts.forEach(function(account) { 
      XMPP.send(account, stanza);
    });
    
    contact.putSidebar(false);
  },  

  removeElement : function(elm) {
    if(this.current == elm && this.isVisible())
      papayaUI.setPanel("papaya-home-container");
  }
}


/***********************************************************************
 *  Section 2: papayaChatUI
 **********************************************************************/
var   papayaChatUI = {
  keyPressEvent : function(evt) {
    var key = evt.keyCode;

    if (key == 13) {
      if(document.getElementById("papaya-im-input").value.length == 0)
        return;

      var text = document.getElementById("papaya-im-input").value;
      papayaChat.send(papayaChat.current, text);
      if(!papayaChat.current.muc) 
        papayaChat.putOut(0, chatParser.parse(text.replace("<", "&lt;").replace(">", "&gt;")));

      document.getElementById("papaya-im-input").reset();
      document.getElementById("papaya-im-input").focus();
      evt.preventDefault();
    }
  },

  inputText : function(text) {
    var input = document.getElementById("papaya-im-input");
    var first = input.value.substring(0, input.selectionStart);
    var cursor = input.selectionEnd;
    var end = input.value.substring(cursor, input.value.length);
    input.value = first + text + end;
    input.setSelectionRange(cursor+ text.length, cursor+ text.length);
    input.focus();
  },
  
  clearInput : function() {
    document.getElementById("papaya-im-input").value = "";
    //document.getElementById("papaya-im-frame").contentDocument.body.innerHTML = "";
    //papayaChat.lastFrom = -1;
  },

  smileyBoxSwitch : function(hide) {
    var smileyBox = document.getElementById("papaya-im-smileybox");

    if(smileyBox.hidden && !hide)   smileyBox.hidden = false;
    else                            smileyBox.hidden = true;
    //doc.contentWindow.scrollBy(0, parseInt(doc.contentDocument.body.clientHeight));
  },

  copyLocation : function() {
    if(papayaStr.stringAtBegin("about:", Browser.selectedBrowser.contentDocument.location))
      this.inputText(Browser.selectedBrowser.contentDocument.location);
  }
}


//FIXME bug with importDialog :-/
var papayaShareContext = {
  prompts : Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService),


  showDialog : function(text) {
    document.getElementById("context-popup").hidden = true;
    document.getElementById("main-context-popup").hidden = true;
    var clist = papayaRoster.contactList;
    var list = new Array();

    var item, subitem;
    for(var i in clist) {
      item = clist[i];
      list.push( {name : item.name,
                  jid : item.getDstJID(),
                  image : item.avatar,
                 });
    }

    clist = papayaRoster.mucList;
    for(var i in clist) {
      if(!clist[i].open) continue;

      item = clist[i];
      list.push( {name : "(muc) " + item.name,
                  jid : item.getDstJID(),
                 });

      for(var k in item.list) {
        if(!item[k]) continue;
        if(!item[k].sidebarObject) continue;
        subitem = item[k];
        list.push( {name : subitem.name,
                    jid : subitem.getDstJID(),
                    image : subitem.avatar,
                   });
      }
    }
    list.sort(function(a, b) { 
        var e = a.name.toLowerCase();
        var f = b.name.toLowerCase();
        return (e == f) ? 0 : 
               (e > f) ? 1 : -1; 
        }
    );

    var params = { text: text, list: list, result : 0 };
    var dialog = importDialog(null, "chrome://papaya/content/share.xul", params);
    dialog.waitForClose();

    return params.result;
  },
  
  shareLink: function() { 
    var lnk = ContextHelper.linkURL;
    var results = this.showDialog("Select a contact to share this link");

    if(results)
    for each(result in results) {
      var dst = papayaRoster.returnPresence(result);
      papayaChat.send(dst, lnk, "<a href=\"" + lnk + "\">" + lnk + "</a>");
      papayaChat.putOut(dst, "<a onclick=\"openLink('" + lnk + "');\">" + lnk + "</a>");
    }
  },
  shareImage: function() {
    var lnk = ContextHelper.mediaURL;
    var results = this.showDialog("Select a contact to share this image");

    if(results)
    for each(result in results) {
      var dst = papayaRoster.returnPresence(result);
      papayaChat.send(dst, lnk, "<img src=\"" + lnk + "\" alt=\"" + lnk + "\"/>");
      papayaChat.putOut(dst, "<img src=\"" + lnk + "\"/>");
    }
  },
  shareCurrent: function() {
    var results = this.showDialog("Select a contact to share this page");

    if(results)
    for each(result in results) {
      var lnk = Browser.selectedBrowser.contentDocument.location;
      var title = Browser.selectedBrowser.contentDocument.title;
      var dst = papayaRoster.returnPresence(result);
      papayaChat.send(dst, lnk, "<a href=\"" + lnk + "\">" + title + "</a>");
      papayaChat.putOut(dst, "<a onclick=\"openLink('" + lnk + "');\">" + title + "</a>");
    }
  },
  shareAudio: function() {
    var lnk = this.contextMenu.URL;
    var results = this.showDialog("Select a contact to share this song");

    if(results)
    for each(result in results) {
      var dst = papayaRoster.returnPresence(result);
      papayaChat.send(dst, lnk, "<audio src=\"" + lnk + "\" alt=\"" + lnk + "\" controls=\"controls\"><a href=\"" + lnk + "\">"+ lnk + "</a></audio>");
      papayaChat.putOut(dst, "<audio src=\"" + lnk + "\" controls=\"controls\"><a onclick=\"openLink('" + lnk + "');\">"+ lnk + "</a></audio>");
    }
  },
  shareVideo: function() {
    var lnk = this.contextMenu.URL;
    var results = this.showDialog("Select a contact to share this video");

    if(results)
    for each(result in results) {
      var dst = papayaRoster.returnPresence(result);
      papayaChat.send(dst, lnk, "<video src=\"" + lnk + "\" alt=\"" + lnk + "\" controls=\"controls\"><a href=\"" + lnk + "\">"+ lnk + "</a></video>");
      papayaChat.putOut(dst, "<video src=\"" + lnk + "\" controls=\"controls\"><a onclick=\"openLink('" + lnk + "');\">"+ lnk + "</a></video>");
    }
  },
  shareText: function(edit) {
    var lnk = Browser.selectedBrowser.contentDocument.location;
    var text = this.contextMenu.text;
    text = chatParser.stripHTML(text);

    var results = this.showDialog("Select a contact to share this text");
    if(results)
    for each(result in results) {
      var dst = papayaRoster.returnPresence(result);
      papayaChat.send(dst, text);
      papayaChat.putOut(dst, "<a onclick=\"openLink('" + lnk + "');\">" + text.replace("<", "&lt;").replace(">", "&gt;") + "</a>");
    }
  },

  
  contextMenu : {
    URL : null,
    text : null,
    currentType : null,
    popupNode : null,

    _clearState : function() {
      this.URL = null;
      this.text = null;
      this.currentType = null;
      this.popupNode = null;
    },

    init : 0,
    _showMenu : function(type, title) {    
      document.getElementById("main-context-hint").value = title;
      
      //Adapted from the Fennec Code
      let commands = document.getElementById("main-context-commands");
      let first = null;
      let last = null;
      for(let i = 0; i < commands.childElementCount; ++i) {
        let command = commands.children[i];
        command.removeAttribute("selector");
        
        if(command.getAttribute("type") != type)
          command.hidden = true;
        else {
          command.hidden = false;
          if(!first) first = command;
          last = command;
        }
      }
      
      if(!first)        return false;
      first.setAttribute("selector", "first-child");
      last.setAttribute("selector", "last-child");

      //The code of this function until the next comment is taken
      //from the Fennec code
      let container = document.getElementById("main-context-popup");
      container.hidden = false;

      let preferredHeight = 0;
      for (let i=0; i<container.childElementCount; i++) {
        preferredHeight += container.children[i].getBoundingClientRect().height;
      }
 
      let rect = container.getBoundingClientRect();
      let height = Math.min(preferredHeight, 0.75 * window.innerWidth);
      let width = Math.min(rect.width, 0.75 * window.innerWidth);

      container.height = height;
      container.width = width;
      container.top = (window.innerHeight - height) / 2;
      container.left = (window.innerWidth - width) / 2;
      BrowserUI.pushPopup(this, [container]);
      //next comment
      
      return true;
    },
    
    handleEvent: function(aEvent) {
      this._clearState();

      let [elementX, elementY] = Browser.transformClientToBrowser(aEvent.clientX, aEvent.clientY);
      this.popupNode = Browser.elementFromPoint(elementX, elementY);

      let tag = this.popupNode.tagName.toLowerCase();
      let result;
      if(this.isAudio(tag)) {
        this.URL = this.popupNode.src;
        this.currentType = "audio";
        result = this._showMenu("audio", this.URL);
      }
      else if(this.isVideo(tag)) {
        this.URL = this.popupNode.src;
        this.currentType = "video";
        result = this._showMenu("video", this.URL);
      }
      else if(this.isText(tag)) {
        this.text = this.popupNode.innerHTML;
        this.currentType = "text";
        result = this._showMenu("text", this.text);
      }
      else {
        this._clearState();
        
        return;
      }

    },
    
    hide: function() {
     this._clearState();

     let container = document.getElementById("main-context-popup");
     container.hidden = true;
 
     BrowserUI.popPopup();
    },
    
    isText : function(tag) {
      return (tag == "span" || tag == "p" || tag == "div" ||
              tag == "li" || tag == "pre" || tag == "ol" ||
              tag == "h1" || tag == "h2" || tag == "h3" || 
              tag == "h4" || tag == "h5" || tag == "h6" || 
              tag == "cite" || tag == "quote" || tag == "acronym" ||
              tag == "em" || tag == "blockquote" || tag == "strong" ||
              tag == "i" || tag == "b" || tag == "u" ||
              tag == "dfn");
              //~ tag == "" || tag == "" || tag == "" ||
    },
    
    isAudio : function(tag) {
      return (tag == "audio");
    },
    
    isVideo : function(tag) {
      return (tag == "video");
    },
  },
}
document.getElementById("tile-container").addEventListener("contextmenu", papayaShareContext.contextMenu, false);
