var account = {};
var XMPP = {};
Components.utils.import('resource://xmpp4moz/xmpp.jsm');
Components.utils.import("resource://papaya/namespaces.jsm");
Components.utils.import("resource://papaya/xmpp.jsm");


function channels() {
  //~ var channel = XMPP.createChannel(
    //~ <query xmlns={ns_disco_info}>
      //~ <feature var={ns_xhtml_im}/>
      //~ <feature var={ns_nick}/>
      //~ <feature var={ns_nick_notify}/>
    //~ </query>);
  var channel = XMPP.createChannel();
  channel.on(
    function(ev) ev.name == 'connector',
    function(connector) {
        switch(connector.state) {
        case 'disconnected':
        case 'active':
            updateUI();
            break;
        }
    });
  //presence
  channel.on(
    function(ev) (ev.name == 'presence' &&
                  ev.dir == 'in'
                  ),
    function(iq) {
      papayaRoster.setXMLPresence(iq.stanza);
    }
  );
  
  //vcard avatar update
  channel.on(
    function(ev) (ev.name == 'presence' &&
                  ev.dir == 'in' &&
                  ev.xml..ns_vcard_update::photo.toString().length > 0
                  ),
    function(iq) {
      avatar.metadata(papayaStr.getBareJID(iq.stanza.@from.toString()), iq.stanza..ns_vcard_update::photo.toString());
    }
  );
  //vCard avatar
  channel.on(
    function(ev) (ev.name == 'iq' &&
                  ev.dir == 'in' &&
                  ev.type == 'result' &&
                  ev.xml..ns_vcard::BINVAL.toString().length > 0
                  ),
    function(iq) {
      var aFrom = papayaStr.getBareJID(iq.stanza.@from.toString());
      var aData = iq.stanza..ns_vcard::BINVAL.toString();
      var aType = iq.stanza..ns_vcard::TYPE.toString();
      avatar.data(aFrom, aData, aType);
    }
  );
  //roster
  channel.on(
    function(ev) (ev.name == 'iq' &&
                  ev.dir == 'in' &&
                  ev.type == 'result' &&
                  ev.xml..ns_roster::query.length() > 0
                  ),
    function(iq) {
      papayaRoster.loadRoster(iq.stanza..ns_roster::item);
    }
  );
  //new contact in roster
  channel.on(
    function(ev) (ev.name == 'iq' &&
                  ev.dir == 'in' &&
                  ev.type == 'set' &&
                  ev.xml..ns_roster::query.length() > 0 &&
                  ev.xml..ns_roster::item.@subscription.length() == 0
                  ),
    function(iq) {
      papayaRoster.addContactXML(iq.stanza);
    }
  );
  //removed contact in roster
  channel.on(
    function(ev) (ev.name == 'iq' &&
                  ev.dir == 'in' &&
                  ev.type == 'set' &&
                  ev.xml..ns_roster::query.length() > 0 &&
                  ev.xml..ns_roster::item.@subscription.toString() == 'remove'
                  ),
    function(iq) {
      papayaRoster.removeContactXML(iq.stanza);
    }
  );
  //bookmarks
  channel.on(
    function(ev) (ev.name == 'iq' &&
                  ev.dir == 'in' &&
                  ev.type == 'result' &&
                  ev.xml..*::conference.toString().length > 0
                  ),
    function(iq) {
      papayaRoster.loadMucs(iq.stanza..ns_bookmarks::conference);
    }
  );
  //contact disconnected
  channel.on(
    function(ev) (ev.name == 'presence' &&
                  ev.dir == 'in' &&
                  ev.xml.@type == "unavailable"
                  ),
    function(iq) {
      papayaRoster.removePresence(iq.stanza.@from.toString());
    }
  );
  //message in
  channel.on(
    function(ev) (ev.name == 'message' &&
                  ev.dir == 'in' &&
                  (ev.type == 'chat' || ev.type == 'groupchat' ||
                   ev.type == 'normal') &&
                  ev.xml.body.length() > 0
                  ),
    function(iq) {
      papayaChat.message(iq.stanza);
    }
  );
  //nick
  channel.on(
    function(ev) (ev.name == 'message' &&
                  ev.dir == 'in' &&
                  ev.xml..ns_nick::nick.length() > 0),
    function(iq) {
      papayaRoster.setNick(iq.stanza.@from.toString(), iq.stanza..*::nick.toString());
    }
  );
  //contact request subscribe
  channel.on(
    function(ev) (ev.name == 'presence' &&
                  ev.dir == 'in' &&
                  ev.xml.@type == "subscribe"
                  ),
    function(iq) {
      handshake.subscribeHandler(iq.stanza.@from.toString());
    }
  );
  //FIXME
  //contact has deny presence request to you
  //~ channel.on(
    //~ function(ev) (ev.name == 'presence' &&
                  //~ ev.dir == 'in' &&
                  //~ ev.xml.@type == "unsubscribed"
                  //~ ),
    //~ function(iq) {
      //~ handshake.unsubscribeHandler(iq.stanza.@from.toString());
    //~ }
  //~ );
};
