var EXPORTED_SYMBOLS = ["chatParser", "papayaStr"];

var chatParser={
  symbols : [
              {info: "smiley/biggrin.png", cString: ":D", toolbar: 1}, 
              {info: "smiley/biggrin.png", cString: ":-D", toolbar: 0},
              
              {info: "smiley/smile.png", cString: ":)", toolbar: 1},
              {info: "smiley/smile.png", cString: ":-)", toolbar: 0},

              {info: "smiley/heart.png", cString: "<3", toolbar: 1},
              {info: "smiley/heart.png", cString: "(l)", toolbar: 0},

              {info: "smiley/angry.png", cString: ":-@", toolbar: 0}, 
              {info: "smiley/angry.png", cString: ":@", toolbar: 1},
              
              
              {info: "smiley/oh.png", cString: ":o", toolbar: 1},
              {info: "smiley/oh.png", cString: ":-o", toolbar: 0},
              {info: "smiley/oh.png", cString: ":-O", toolbar: 0},
              {info: "smiley/oh.png", cString: ":O", toolbar: 0},

              {info: "smiley/unhappy.png", cString: ":(", toolbar: 1},
              {info: "smiley/unhappy.png", cString: ":-(", toolbar: 0},
              
              {info: "smiley/wink.png", cString: ";)", toolbar: 1},
              {info: "smiley/wink.png", cString: ";-)", toolbar: 0},
              
              {info: "smiley/coolglasses.png", cString: "8-)", toolbar: 1},
              {info: "smiley/coolglasses.png", cString: "8)", toolbar: 0},
              
              {info: "smiley/cry.png", cString: ":'(", toolbar: 0},
              {info: "smiley/cry.png", cString: ";(", toolbar: 1},
              
              {info: "smiley/devil.png", cString: "(6)", toolbar: 1},
            ],

  xhtmlTags : new Array(),
  xhtmlStyle : ["background-color", "color", "font-family", "font-size",
                "font-weight", "margin-left", "margin-right", "text-align",
                "text-decoration"],

  init : function() {
    var xhtmlTags = this.xhtmlTags;
    xhtmlTags["blockquote"] = {};
    xhtmlTags["br"] = {};
    xhtmlTags["cite"] = {tag: "i"};
    xhtmlTags["code"] = {tag: "i"};
    xhtmlTags["dfn"] = {tag: "i"};
    //~ xhtmlTags["div"] = {startCode: "", endCode: "", attribute : new Array()};
    xhtmlTags["em"] = {tag: "b"};
    xhtmlTags["h1"] = {};     xhtmlTags["h2"] = {};
    xhtmlTags["h3"] = {};     xhtmlTags["h4"] = {};
    xhtmlTags["h5"] = {};     xhtmlTags["h6"] = {};
    xhtmlTags["p"] = {};      xhtmlTags["pre"] = {};
    xhtmlTags["div"] = {};    xhtmlTags["span"] = {};
    xhtmlTags["q"] = {};      xhtmlTags["strong"] = {tag : "b"};
    xhtmlTags["dl"] = {};     xhtmlTags["dt"] = {};
    xhtmlTags["dd"] = {};     xhtmlTags["ol"] = {};
    xhtmlTags["ul"] = {};     xhtmlTags["li"] = {};
    xhtmlTags["a"] = {attributes : ["title",  "href", "type"]};
    xhtmlTags["img"] = {attributes : ["src", "alt", "height", "width"]};
    
    //NON STANDARDS but accepteds
    xhtmlTags["u"] = {};     xhtmlTags["i"] = {};
    xhtmlTags["b"] = {};     xhtmlTags["audio"] = {};
    xhtmlTags["video"] = {};
  },

  xhtmlSecure : function(xml, parentIsLink) {
    //TODO: attribute
    var result = "";
    var tag, item;

    for(var i = 0; xml[i]; i++) {
      if((tag = xml[i].name())) {
        item = this.xhtmlTags[tag.localName];

        if(!item)   item = this.xhtmlTags[tag];
        if(!item)   continue;

        item = xml[i];
        if(tag.localName == "a"){
          item.@onclick="openLink(" + item.@href.toString() + ");";
          if(item.*.length())  item += this.xhtmlSecure(xml[i].*, true);
        }
        else 
          if(item.*.length()) item += this.xhtmlSecure(xml[i].*, parentIsLink);

        result += xml[i].toXMLString();
      }
      else {
        item = xml[i].toString().replace("<", "&lt;").replace(">", "&gt;");
        result += this.parse(item, parentIsLink);
      }
    }
    
    return result;
  },

  parse : function(text, disableUrl) {
    text = this.replaceSymbols(text);
    if(!disableUrl) text = this.replaceUrl(text);
    return text;
  },

  toInfosDiv : function(text) {
    return 	"<div class=\"item item_info\">" + text + "</div>";
  },

  toMucDiv : function(pseudo, avatar, text) {
    return 	"<div class=\"item item_muc\"><img src=\"" + avatar + 
            "\" class=\"muc_avatar\"><span class=\"muc_nickname\">" + pseudo + "</span>" + text + "</div>";
  },

  toInDiv : function(text, avatar) {
    return 	"<div class=\"item item_in\"><img src=\"" + avatar + "\" class=\"avatar\" style=\"float: left;\">" + text + "</div>";
  },
  
  toOutDiv : function(text, avatar) {
    return 	"<div class=\"item item_out\"><img src=\"" + avatar + "\" class=\"avatar\" style=\"float: right;\">" + text + "</div>";
  },


  replaceSymbols: function(text) {
    var result = "";

    var i, j, k;
    var allright;

    allright = 0; //marker

    //for each character in the text
    for(i=0; i < text.length; ++i) {
      //there must be a space car before the smiley
      //if prec was not a smiley
      if(i > 0 && allright == 0) {
        k = text[i-1];

        if(k != " " && k != "\n" && k != "\t") {
          result = result + text[i];
          continue;
        }
      }

      //for each symbol, compare
      for(j=0; j < this.symbols.length; ++j) {
        allright = 1;

        for(k=0; k<this.symbols[j].cString.length; ++k)
          if(this.symbols[j].cString[k] != text[i+k]) {
            allright = 0;
            break;
          }

        if(allright == 1) {
          result = result + "<img src=\"" + this.symbols[j].info + "\" class=\"smiley\">";
          i += k - 1;
          break;
        }
      } //for(j)

      if(allright == 0)
        result = result + text[i];
    } //for(i)

    return result;
  },

  replaceUrl : function(text) {
    let regex = new RegExp("https?://(\\S+)", "gi");
    return text.replace(regex, "<a onclick=\"openLink('$&');\">$&</u>");
  },
  
  stripHTML : function(text){
    var re = /(<([^>]+)>)/gi;
    return text.replace(re, "");
  },
};

var papayaStr = {
  /*! If a string is empty or just made with space, return true, else false
   */
  isEmpty : function(text) {
    if(text.length == 0)   
      return true;

    for(var i=0; i<= text.length; ++i)
      if(text[i] != " " && text[i]!="\t" && text[i]!="\n")
        return false;

    return true;
  },

  /*! Replace the first occurence of a string "str" with "nstr" in "text"
   *  Doesn't use Regex
   */
  replace : function(text, str, nstr) {
    var result = "";
    
    //find:
    var k=0;
    for(var i = 0; i < text.length && k < str.length; ++i) {
      if(text[i] == str[k])
        ++k;
      else
        k = 0;
    }
    
    //no found
    if(k != str.length) {
      return text;
    }
    
    result = text.substring(0, i - str.length);
    result+= nstr;
    result+= text.substring(i, text.length);
    return result;
  },

  /*! Replace the occurence if found at the begin
   */
  replaceAtBegin : function(src, str, nstr) {
    if(str.length > src.length)
      return src;

    if(!this.stringAtBegin(str, src))
      return src;

    src = nstr + src.substr(str.length);

    return src;
  },

  /*!   This function return 1 if str1 is in str2, 0 else
   */
  stringAtBegin : function(str1, str2) {
    return (str2.search(str1) == 0);
  },
  
  /*! Return true if str is in src
   */
  isSubString : function(src, str) {
    if(str.length > src.length)
      return false;

    str = (new String(str)).toLowerCase();
    src = (new String(src)).toLowerCase();
    
    var j;
    var max = src.length - str.length + 1;
    for(var i = 0; i < max; ++i) {
      for(j = 0; j < str.length && src[i+j] == str[j]; ++j);
      if(j == str.length)
        return true;
    }
    return false;
  },


  /* similar as the C function
   */
  strCmp : function(str1, str2) {
    str1 = (new String(str1)).toLowerCase();
    str2 = (new String(str2)).toLowerCase();
    var i;
    
    for(i = 0; i < str1.length && i < str2.length; ++i) {
      if(str1[i] == str2[i]) continue;
      return (str1[i] > str2[i]) ? 1 : -1;
    }

    return (str2.length == str1.length) ? 0 : (str1.length > str2.length) ? 1 : -1;
  },

  /*********************************************************************
   *    JID manipulations
   * We won't use regex object - FIXME: lighter?
   ********************************************************************/
  getResource : function(aFullJID) {
    var regexp = new RegExp("/(.*)", "gim");
    let value = regexp.exec(aFullJID);
    
    return (value) ? value[1] : "";
  },
  getBareJID : function(aFullJID) {
    var regexp = new RegExp("(.*)/", "gim");
    let value = regexp.exec(aFullJID);
    
    return (value) ? value[1] : "";
  },
  getName : function(aJID) {
    var regexp = new RegExp("(.*)@", "gim");
    let value = regexp.exec(aJID);
    
    return (value) ? value[1] : "";
  },
};
